#!/bin/zsh

# EXE is binary filename
# MAIN is main script
# LIBS is space-delimited, must not include main script

if [[ "$1" == "eldritch" ]]; then
	EXE=eldritch
	MAIN=eldritch.scm
	LIBS="marklib.scm"
elif [[ "$1" == "odyssey" ]]; then
	EXE=odyssey
	MAIN=odyssey.scm
	LIBS="marklib.scm graphics.scm"
elif [[ "$1" == "primes" ]]; then
	EXE=primes
	MAIN=primes.scm
	LIBS=""
elif [[ $# -ge 1 ]]; then
	# Single-file project
	EXE=`basename $1 .scm`
	MAIN=$1
	shift
	LIBS="$*"
else
	echo "Usage: build.zsh PROJECT | main.scm [LIBS]"
	echo "Projects: eldritch odyssey"
	exit 0
fi

mkdir -p bin

cd src
for SF in ${=LIBS}; do
	SNAME=`basename $SF .scm`
	# if [[ "$SF" == "$MAIN" ]]; then
	# 	continue
	# fi
	echo "Compiling $SF"
	csc -c -j $SNAME $SF -o $SNAME.o || exit 1
done
echo "Compiling $MAIN"
csc -c $MAIN -o `basename $MAIN .scm`.o || exit 1
echo "Linking..."
csc *.o -o ../bin/$EXE || exit 1
rm -f *.o
rm -f *.import.scm
cd ..

echo "Built bin/$EXE"
